//---------------------------------------------------------------------------

#ifndef ThreadCommH
#define ThreadCommH
//---------------------------------------------------------------------------
#include <deque>
#include "Mutex.h"
#include <dsound.h>
//---------------------------------------------------------------------------

class ThreadComm
{
private:
	typedef void (*CallbackLog)(char*);
	typedef void (*CallbackData)(short*, int);
	typedef void (*CallbackConnect)(int, char*);
	friend DWORD WINAPI ThreadCommProc(LPVOID data);
	friend DWORD WINAPI ThreadRxQueueProc(LPVOID data);
	typedef void (__closure *CallbackDataRcv)(short *data, unsigned int len);

protected:
public:
	bool connected;
	CallbackLog callbackLog;
	CallbackDataRcv callbackDataRcv;
	CallbackConnect callbackConnect;
	__fastcall ThreadComm();

	HANDLE Thread;
	struct DsoundStream {
		LPDIRECTSOUNDCAPTURE	lpDs;
		LPDIRECTSOUNDCAPTUREBUFFER	lpDsBuffer;
		HANDLE		    hEvent;
		LPDIRECTSOUNDNOTIFY	    lpDsNotify;
		DWORD		    dwBytePos;
		DWORD		    dwDsBufferSize;
		unsigned int bytes_per_frame;
		void* buffer;	///< temporary frame buffer
	};
	DsoundStream *stream;

	HANDLE ThreadRxQueue;
	void Execute();
	void log(char *lpData, ...);
};
//---------------------------------------------------------------------------
#endif
